#ifndef _PY_PARSER_VISITOR_H
#define _PY_PARSER_VISITOR_H

#include "pyparser.h"

class PyParserVisitor
{
	public:
		virtual ~PyParserVisitor() {}

		// Expressions
		virtual void visitNumber( object value ) {}
		virtual void visitName( identifier value, expr_context_ty context ) {}
		virtual void visitString( string value ) {}
		virtual void visitCall( expr_ty func, asdl_seq *args, asdl_seq *keywords, expr_ty starargs, expr_ty kwargs ) {}
	
		// Statements
		virtual void visitPrint( expr_ty destination, asdl_seq* values, bool newline ) {}
		virtual void visitReturn( expr_ty value ) {}
		virtual void visitAssign( asdl_seq* targets, expr_ty value ) {}
		virtual void visitFunction( identifier name, arguments_ty arguments, asdl_seq* body, asdl_seq* decorators ) {}
		virtual void visitExpressionStmt( expr_ty statement ) {}
			
		void visitExpression( expr_ty expression );
		void visitStatement( stmt_ty statement );
		void visitStatements( asdl_seq* statements );
};

#endif
